#if defined _checksetting_included
  #endinput
#endif
#define _checksetting_included

#include <plugin>

enum check_type {
    equal,
    contain,
    fileexist
}

forward check_setting(&error,CvarName[],check_type:type,CvarValue[] = "");

stock check_setting(&error,CvarName[],check_type:type,CvarValue[] = "") {
    new CvarData[MAX_DATA_LENGTH];
    getstrvar(CvarName,CvarData,MAX_DATA_LENGTH);
    switch(type) {
        case equal: {
            if(strcmp(CvarData,CvarValue)) {
                snprintf(CvarData,MAX_DATA_LENGTH,"[ERROR]: %s is required to equal %s",CvarName,CvarValue);
                error = 1;
                plugin_message(CvarData);
            }
        }
        case contain: {
            if(strstr(CvarData,CvarValue) == -1) {
                snprintf(CvarData,MAX_DATA_LENGTH,"[ERROR]: %s is required to contain %s",CvarName,CvarValue);
                error = 1;
                plugin_message(CvarData);
            }
        }
        case fileexist: {
            if(!fileexists(CvarData)) {
                snprintf(CvarData,MAX_DATA_LENGTH,"[ERROR]: %s is required to point to a valid file",CvarName);
                error = 1;
                plugin_message(CvarData);
            }
        }
    }
}

stock plugin_safe_register(Name[],Description[],Version[],error) {
    if(!error) {
        plugin_registerinfo(Name,Description,Version);
        return 1;
    }
    plugin_registerinfo(Name,"Erroneus settings detected, view logfile for details","not loaded");
    return 0;
}