#if defined _rindy_included
  #endinput
#endif
#define _rindy_included

stock isnumeric(string[],&num) {
    new i = strlen(string);
    new f = 1;
    new n = 0;
    while(i > 0) {
        i--;
        if('0' <= string[i] <= '9') {
            n += (string[i] - '0') * f;
            f *= 10;
        } else {
            return 0;
        }
    }
    num = n;
    return 1;
}

stock abs(num) { //Returns the positive value of num.
    if(num > 0) {
        return num;
    }
    return -num;
}

stock pow(num,exp) { //Returns the power of num with exp.
    new p = num;
    new i;
    if(exp < 0) {
        return -1;
    } else if(exp == 0) {
        return 1;
    } else {
        for(i=1;i<exp;i++) {
            p *= num;
        }
    }
    return p;
}

stock sqrt(num) { //Returns the approximate square root of num.
    new div = num;
    new result = 1;
    if(num >= 0) {
        while(div > result) {
            div = (div + result) / 2;
            result = num / div;
        }
        return div;
    }
    return -1;
}

stock get_accesslevel(sTarget[] = "") {
    new i,j;
    for(i=1;i<=131072;i<<=1) {
        if(access(i,sTarget) ==1) {
            j &= i;
        }
    }
    return j;
}

stock format_lines(Text[],maxlen,linelen = 79) { //Inserts linebreaks into Text for maxlen characters, so no line gets longer than linelen characters, if possible at a space. Returns length of resulting string.
    new SayText[512];
    new textpos;
    new saytextpos;
    new textlen = min(maxlen,strlen(Text));
    new numtoadd;
    new i;
    while(textlen-textpos > linelen) {
        for(i=textpos+linelen;i>textpos;--i) {
            if(Text[i] == '^n' || Text[i] == ' ' && textpos == numtoadd) {
                numtoadd = i;
            }
        }
        if(numtoadd == textpos) {
            numtoadd = textpos+linelen-1;
        }
        for(i=textpos;i<numtoadd;i++) {
            SayText[saytextpos++] = Text[i];
        }
        SayText[saytextpos++] = '^n';
        if(Text[numtoadd] == ' ' || Text[numtoadd] == '^n') {
            numtoadd++;
        }
        textpos = numtoadd;
    }
    for(i=textpos;i<textlen;i++) {
        SayText[saytextpos++] = Text[i];
    }
    saytextpos = min(saytextpos,maxlen);
    for(i=0;i<saytextpos;i++) {
        Text[i] = SayText[i];
    }
    Text[saytextpos] = '^0';
    return saytextpos;
}

stock vaultdata_init(Key[],Value[],maxlen,def[]) {
    if(!get_vaultdata(Key,Value,maxlen)) {
        strcpy(Value,def,maxlen);
        set_vaultdata(Key,def);
    }
}

stock vaultnumdata_init(Key[],&Value,def) {
    if(!get_vaultnumdata(Key,Value)) {
        Value = def;
        set_vaultnumdata(Key,def);
    }
}

stock get_maxplayers(&var) {
    var = min(maxplayercount(),MAX_PLAYERS);
}