#if defined _rindy_player_helper_included
  #endinput
#endif
#define _rindy_player_helper_included

forward remove_storeddata(i);
forward msg_admins(msg[],flags = FLAG_NOTIFY,exclude = 0);
forward read_flags(str[]);
forward DefaultAccess(HLCommand,HLData,HLUserName,UserIndex);
forward ReloadUsers(HLCommand,HLData,HLUserName,UserIndex);
forward read_file();
forward get_user_line(UserIndex);
forward hash(AuthID[MAX_AUTHID_LENGTH]);

remove_storeddata(i) {
    new j;
    for(j=i+1;j<REMEMBER;j++) {
        strcpy(g_StoreNick[j-1],g_StoreNick[j],MAX_NAME_LENGTH);
        strcpy(g_StoreAuthID[j-1],g_StoreAuthID[j],MAX_AUTHID_LENGTH);
        g_StoreSessionID[j-1] = g_StoreSessionID[j];
        g_StoreFlags[j-1] = g_StoreFlags[j];
        g_StoreTime[j-1] = g_StoreTime[j];
    }
    strinit(g_StoreNick[REMEMBER-1]);
    strinit(g_StoreAuthID[REMEMBER-1]);
    g_StoreSessionID[REMEMBER-1] = 0;
}

msg_admins(msg[],flags = FLAG_NOTIFY,exclude = 0) {
    new Name[MAX_NAME_LENGTH];
    new i;
    for(i=1;i<=g_Maxplayers;i++) {
        if(((g_Flags[i] | g_Defaultflags) & flags) && playerinfo(i,Name,MAX_NAME_LENGTH) && i != exclude) { // When valid player has at least one of required flags
            messageex(Name,msg,print_chat);
            messageex(Name,msg,print_console);
        }
    }
}

read_flags(str[]) {
    new Flags;
    new i;
    while(str[i]) {
        if('a' <= str[i] <= 'z')
            Flags |= 1<<(str[i] - 'a');
        else if('A' <= str[i] <= 'E')
            Flags |= 1<<(str[i] - 'A' + 26);
        i++;
    }
    return Flags;
}

public DefaultAccess(HLCommand,HLData,HLUserName,UserIndex) {
    new Data[MAX_DATA_LENGTH];
    convert_string(HLData,Data,MAX_DATA_LENGTH);
    g_Defaultflags = read_flags(Data);
    set_serverinfo("default_flags",Data);
    return PLUGIN_HANDLED;
}

public ReloadUsers(HLCommand,HLData,HLUserName,UserIndex) {
    new i;
    new UserName[MAX_NAME_LENGTH];
    read_users();
    for(i=1;i<=g_Maxplayers;i++) {
        if(playerinfo(i,UserName,MAX_NAME_LENGTH)) {
            g_Line[i] = get_user_line(i);
            if(((g_Flags[i] = g_FiledataFlags[g_Line[i]][0]) & FLAG_AUTH) && auth(UserName)) // get his flags
                g_Flags[i] = g_FiledataFlags[g_Line[i]][1] & ~FLAG_AUTH;
        }
    }
    log("File reloaded.");
    return PLUGIN_HANDLED;
}

read_users() {
    new LineData[MAX_DATA_LENGTH];
    new Line;
    new Flags[2][MAX_FLAG_LENGTH];
    new h,i,b,c;
    g_FiledataLinecount = 0;
    for(i=0;i<HASHTABLESIZE;i++) {
        g_Hashtable[i] = 0;
    }
       
    while(readfile(g_Usersfile,LineData,++Line,MAX_DATA_LENGTH)) { // Read all lines
        if(LineData[0] == '#' || LineData[0] == ';' || (LineData[0] == '/' && LineData[1] == '/') || LineData[0] == '^0') // If commented out with '#', ';' or '//' at begin of line or line is zero length, continue
            continue;
        if(g_FiledataLinecount == MAX_ENTRIES) {
            log("[ERROR] (plugin_rindy_player): The usersfile is too long, increase MAX_ENTRIES and recompile!");
            break;
        }
        g_FiledataLinecount++;

        strgsplit(LineData," ","^"",g_FiledataAuthID[g_FiledataLinecount],MAX_AUTHID_LENGTH,Flags[0],MAX_FLAG_LENGTH,Flags[1],MAX_FLAG_LENGTH);
        g_FiledataFlags[g_FiledataLinecount][0] = read_flags(Flags[0]);
        g_FiledataFlags[g_FiledataLinecount][1] = read_flags(Flags[1]);

        h = hash(g_FiledataAuthID[g_FiledataLinecount]);
        if(!g_Hashtable[h]) {
            g_Hashtable[h] = g_FiledataLinecount;
        } else {
            b = g_Hashtable[h];
            do {
                i = b;
                if((c = strcmp(g_FiledataAuthID[g_FiledataLinecount],g_FiledataAuthID[i])) > 0) {
                    b = g_FiledataLeft[i];
                } else {
                    b = g_FiledataRight[i];
                }
            } while(b);
            if(c > 0) {
                g_FiledataLeft[i] = g_FiledataLinecount;
            } else {
                g_FiledataRight[i] = g_FiledataLinecount;
            }
        }
        g_FiledataLeft[g_FiledataLinecount] = 0;
        g_FiledataRight[g_FiledataLinecount] = 0;
    }
    
}

get_user_line(UserIndex) {
    new i = g_Hashtable[hash(g_AuthID[UserIndex])];
    new c;
    while(i && (c = strcmp(g_AuthID[UserIndex],g_FiledataAuthID[i]))) {
        if(c > 0)
            i = g_FiledataLeft[i];
        else
            i = g_FiledataRight[i];
    }
    return i;
}

hash(AuthID[MAX_AUTHID_LENGTH]) {
    new h;
    new i;
    while(AuthID[i]) {
        h = ((h<<1) ^ AuthID[i]) & (HASHTABLESIZE - 1);
        i++;
    }
    return h;
}

read_reasons() {
    strcpy(g_Reasons[0],"no reason",MAX_REASON_LENGTH);
    g_LoadedReasons = 1;
    while(g_LoadedReasons < MAX_REASONS && readfile(g_Reasonsfile,g_Reasons[g_LoadedReasons],g_LoadedReasons,MAX_REASON_LENGTH)) {
        g_LoadedReasons++;
    }
}

// simple storage without hashing/trees
/*
read_users() {
    new LineData[MAX_DATA_LENGTH];
    new Line;
    new Flags[2][MAX_FLAG_LENGTH];
    g_FiledataLinecount = 0;
    while(readfile(g_Usersfile,LineData,++Line,MAX_DATA_LENGTH)) { // Read all lines
        if(LineData[0] == '#' || LineData[0] == ';' || (LineData[0] == LineData[1] == '/') || LineData[0] == '^0') // If commented out with '#', ';' or '//' at begin of line or line is zero length, continue
            continue;
        if(g_FiledataLinecount == MAX_ENTRIES) {
            log("[ERROR] (plugin_rindy_player): The usersfile is too long, increase MAX_ENTRIES and recompile!");
            break;
        }
        g_FiledataLinecount++;
        strsep(LineData,":",g_FiledataAuthID[g_FiledataLinecount],MAX_AUTHID_LENGTH,Flags[0],MAX_FLAG_LENGTH,Flags[1],MAX_FLAG_LENGTH,g_FiledataNames[g_FiledataLinecount],MAX_NAMELIST_LENGTH);
        g_FiledataFlags[g_FiledataLinecount][0] = read_flags(Flags[0]);
        g_FiledataFlags[g_FiledataLinecount][1] = read_flags(Flags[1]);
    }
}

get_user_line(UserIndex) {
    new i;
    for(i=1;i<=g_FiledataLinecount;i++) {
        if(!strcmp(g_AuthID[UserIndex],g_FiledataAuthID[i])) {
            return i;
            break;
        }
    }
    return 0;
}
*/