#if defined _rindy_player_infos_included
  #endinput
#endif
#define _rindy_player_infos_included

forward find_player(Target[MAX_AUTHID_LENGTH],&present,&index);
forward get_player_information(present,index,UserName[MAX_NAME_LENGTH],&UserSessionID,UserAuthID[MAX_AUTHID_LENGTH],UserTeam[MAX_NAME_LENGTH]);
forward check_present_ids(SessionID,&index);
forward check_left_ids(SessionID,&index);
forward check_present_names(Name[MAX_AUTHID_LENGTH],&index);
forward check_left_names(Name[MAX_AUTHID_LENGTH],&index);
forward check_present_authids(AuthID[MAX_AUTHID_LENGTH],&index);
forward check_left_authids(AuthID[MAX_AUTHID_LENGTH],&index);


find_player(Target[MAX_AUTHID_LENGTH],&present,&index) {
    new ID;
    if(Target[0] == '#' && isnumeric(Target[1],ID)) {
        if(check_present_ids(ID,index) == PLAYER_FOUND) {
            present = 1;
            return PLAYER_FOUND;
        }
        if(check_left_ids(ID,index) == PLAYER_FOUND) {
            present = 0;
            return PLAYER_FOUND;
        }
    }
    switch(check_present_names(Target,index)) {
        case PLAYER_FOUND: {
            present = 1;
            return PLAYER_FOUND;
        }
        case PLAYER_NOTUNIQUE: {
            return PLAYER_NOTUNIQUE;
        }
    }
    switch(check_left_names(Target,index)) {
        case PLAYER_FOUND: {
            present = 0;
            return PLAYER_FOUND;
        }
        case PLAYER_NOTUNIQUE: {
            return PLAYER_NOTUNIQUE;
        }
    }
    if(check_present_authids(Target,index) == PLAYER_FOUND) {
        present = 1;
        return PLAYER_FOUND;
    }
    if(check_left_authids(Target,index) == PLAYER_FOUND) {
        present = 0;
        return PLAYER_FOUND;
    }
    return PLAYER_NOTFOUND;
}

get_player_information(present,index,UserName[MAX_NAME_LENGTH],&UserSessionID,UserAuthID[MAX_AUTHID_LENGTH],UserTeam[MAX_NAME_LENGTH]) {
    new Team;
    if(present) {
        playerinfo(index,UserName,MAX_NAME_LENGTH,UserSessionID,_,Team);
        strcpy(UserAuthID,g_AuthID[index],MAX_AUTHID_LENGTH);
    } else {
        strcpy(UserName,g_StoreNick[index],MAX_NAME_LENGTH);
        UserSessionID = g_StoreSessionID[index];
        strcpy(UserAuthID,g_StoreAuthID[index],MAX_AUTHID_LENGTH);
        Team = 0;
    }
    switch(Team) {
        case 1: strcpy(UserTeam,"TERRORIST",MAX_NAME_LENGTH);
        case 2: strcpy(UserTeam,"CT",MAX_NAME_LENGTH);
        case TEAM_SPECTATOR: strcpy(UserTeam,"SPECTATOR",MAX_NAME_LENGTH);
        case TEAM_PROXY: strcpy(UserTeam,"PROXY",MAX_NAME_LENGTH);
        default: strcpy(UserTeam,"",MAX_NAME_LENGTH);
    }
}

check_present_ids(SessionID,&index) {
    new i;
    for(i=1;i<=g_Maxplayers;i++) {
        if(g_SessionID[i] == SessionID) {
            index = i;
            return PLAYER_FOUND;
        }
    }
    return PLAYER_NOTFOUND;
}

check_left_ids(SessionID,&index) {
    new i;
    for(i=0;i<REMEMBER;i++) {
        if(g_StoreSessionID[i] == SessionID) {
            index = i;
            return PLAYER_FOUND;
        }
    }
    return PLAYER_NOTFOUND;
}

check_present_names(Name[MAX_AUTHID_LENGTH],&index) {
    new UserName[MAX_NAME_LENGTH];
    new found;
    new found_index;
    new i;
    for(i=1;i<=g_Maxplayers;i++) {
        if(g_SessionID[i] && playerinfo(i,UserName,MAX_NAME_LENGTH)) {
            if(strcasestr(UserName,Name) > -1) {
                if(found) {
                    return PLAYER_NOTUNIQUE;
                } else {
                    found = 1;
                    found_index = i;
                }
            }
        }
    }
    if(found) {
        index = found_index;
        return PLAYER_FOUND;
    }
    return PLAYER_NOTFOUND;
}

check_left_names(Name[MAX_AUTHID_LENGTH],&index) {
    new found;
    new found_index;
    new i;
    for(i=0;i<REMEMBER;i++) {
        if(g_SessionID[i]) {
            if(strcasestr(g_StoreNick[i],Name) > -1) {
                if(found) {
                    return PLAYER_NOTUNIQUE;
                } else {
                    found = 1;
                    found_index = i;
                }
            }
        }
    }
    if(found) {
        index = found_index;
        return PLAYER_FOUND;
    }
    return PLAYER_NOTFOUND;
}

check_present_authids(AuthID[MAX_AUTHID_LENGTH],&index) {
    new i;
    for(i=1;i<=g_Maxplayers;i++) {
        if(!strcmp(g_AuthID[i],AuthID)) {
            index = i;
            return PLAYER_FOUND;
        }
    }
    return PLAYER_NOTFOUND;
}

check_left_authids(AuthID[MAX_AUTHID_LENGTH],&index) {
    new i;
    for(i=0;i<REMEMBER;i++) {
        if(!strcmp(g_StoreAuthID[i],AuthID)) {
            index = i;
            return PLAYER_FOUND;
        }
    }
    return PLAYER_NOTFOUND;
}